﻿using Modbus.Device;
using System;
using System.Diagnostics.Metrics;
using System.IO.Ports;
using System.Threading;
using System.Threading.Tasks;


namespace ApiServer
{
	public class GetActualStateFromComWithModbus : IHostedService, IDisposable
	{
		public static bool[] CurrentState { get; set; }

		static SerialPort _serialPort;
		static ModbusSerialMaster _serialMaster;

		static void DataReceivedHandler(object sender, SerialDataReceivedEventArgs e)
		{
			_serialMaster = ModbusSerialMaster.CreateRtu(_serialPort);

			byte slaveID = 1;
			ushort startAddress = 0;
			ushort numOfPoints = 2;
			CurrentState = _serialMaster.ReadInputs(slaveID, startAddress, numOfPoints);
		}

		public Task StartAsync(CancellationToken cancellationToken)
		{
			_serialPort = new SerialPort();
			_serialPort.PortName = "COM5";
			_serialPort.BaudRate = 9600;
			_serialPort.DataBits = 8;
			_serialPort.Parity = Parity.None;
			_serialPort.StopBits = StopBits.One;
			_serialPort.DataReceived += new SerialDataReceivedEventHandler(DataReceivedHandler);
			_serialPort.Open();

			return Task.CompletedTask;
		}

		public Task StopAsync(CancellationToken cancellationToken)
		{
			return Task.CompletedTask;
		}

		public void Dispose()
		{
			_serialPort.Dispose();
		}
	}
}
